<sqtm-core-creation-dialog
  (add)="addEntity()"
  (addAnother)="addAnother()"
  [asyncTaskRunning]="loading$ | async"
  [attr.data-test-dialog-id]="'new-entity'"
>
  <div class="m-10" [formGroup]="formGroup">
    <div class="sqtm-core-dialog-form">
      <label class="label label__align_right">{{
        'sqtm-core.entity.generic.name.label' | translate
      }}</label>
      <sqtm-core-text-field
        [initialFocus]="true"
        [formGroup]="formGroup"
        [fieldName]="'name'"
        [serverSideFieldValidationError]="serverSideValidationErrors"
      >
      </sqtm-core-text-field>
      <label class="label label__align_right">{{
        'sqtm-core.generic.label.label' | translate
      }}</label>
      <sqtm-core-text-field
        [formGroup]="formGroup"
        [fieldName]="'label'"
        [serverSideFieldValidationError]="serverSideValidationErrors"
      >
      </sqtm-core-text-field>
      <label class="label label__align_right">{{
        'sqtm-core.generic.label.code' | translate
      }}</label>
      <sqtm-core-text-field
        [formGroup]="formGroup"
        [fieldName]="'code'"
        [serverSideFieldValidationError]="serverSideValidationErrors"
      >
      </sqtm-core-text-field>
      <label class="label label__align_right">{{
        'sqtm-core.entity.custom-field.input-type.label' | translate
      }}</label>
      <sqtm-core-select-field
        [formGroup]="formGroup"
        [fieldName]="'inputType'"
        [options]="inputTypeOptions"
        [serverSideFieldValidationError]="serverSideValidationErrors"
      >
      </sqtm-core-select-field>
      @if (!isCheckbox) {
        <label class="label label__align_right">{{
          'sqtm-core.entity.custom-field.optional.label' | translate
        }}</label>
        <span
          nz-checkbox
          style="justify-self: start"
          class="m-auto-0"
          [formGroup]="formGroup"
          formControlName="optional"
          ngDefaultControl
          [attr.data-test-field-name]="'optional'"
        >
        </span>
      }

      @if (!isDropdownList) {
        <label class="label label__align_right">{{
          'sqtm-core.entity.custom-field.default-value.label' | translate
        }}</label>
      }
      @if (!isDropdownList) {
        @switch (formGroup.get('inputType').value) {
          @case ('PLAIN_TEXT') {
            <sqtm-core-text-field
              [formGroup]="formGroup"
              [fieldName]="'defaultText'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-text-field>
          }
          @case ('CHECKBOX') {
            <sqtm-core-select-field
              [formGroup]="formGroup"
              [fieldName]="'defaultChecked'"
              [options]="defaultCheckedOptions"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-select-field>
          }
          @case ('DATE_PICKER') {
            <sqtm-core-date-picker
              [formGroup]="formGroup"
              [fieldName]="'defaultDate'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
              [allowEmptyValue]="!isMandatory"
            >
            </sqtm-core-date-picker>
          }
          @case ('RICH_TEXT') {
            <sqtm-core-rich-text-field
              [formGroup]="formGroup"
              [fieldName]="'defaultRichText'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-rich-text-field>
          }
          @case ('TAG') {
            <sqtm-core-select-field
              [formGroup]="formGroup"
              [fieldName]="'defaultTags'"
              [mode]="'tags'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-select-field>
          }
          @case ('NUMERIC') {
            <sqtm-core-text-field
              [formGroup]="formGroup"
              [fieldName]="'defaultNumeric'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-text-field>
          }
        }
      }
    </div>
    @if (isDropdownList) {
      <ng-container [formGroup]="dropdownListFormGroup">
        <label class="block-title">{{
          'sqtm-core.entity.option.label.plural' | translate
        }}</label>
        <div class="block-border m-t-10">
          <div class="full-column-span sqtm-core-dialog-form">
            <label class="label label__align_right">{{
              'sqtm-core.entity.generic.name.label' | translate
            }}</label>
            <sqtm-core-text-field
              [initialFocus]="true"
              [formGroup]="dropdownListFormGroup"
              [fieldName]="'dropdownListOptionName'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-text-field>
            <label class="label label__align_right">{{
              'sqtm-core.generic.label.code' | translate
            }}</label>
            <sqtm-core-text-field
              [formGroup]="dropdownListFormGroup"
              [fieldName]="'dropdownListOptionCode'"
              [serverSideFieldValidationError]="serverSideValidationErrors"
            >
            </sqtm-core-text-field>

            <button
              style="width: max-content"
              class="grid-column-start-2"
              [attr.data-test-dialog-button-id]="'add-option'"
              nz-button
              nzType="primary"
              (click)="addDropdownListOption()"
            >
              {{ 'sqtm-core.entity.custom-field.add-option.label' | translate }}
            </button>
          </div>
          <div class="full-column-span">
            <sqtm-core-grid></sqtm-core-grid>
          </div>
          @if (hasDropdownListDefaultError$ | async) {
            <span
              class="sqtm-core-error-message"
              [attr.data-test-error-key]="'default-option-required'"
            >
              {{
                'sqtm-core.error.custom-field.dropdown-list.required-default-option.generic'
                  | translate
              }}
            </span>
          }
        </div>
      </ng-container>
    }
  </div>
</sqtm-core-creation-dialog>
